package com.kexun.common;

import com.alibaba.fastjson.JSONObject;
import org.apache.commons.codec.Charsets;

import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import java.util.HashMap;
import java.util.Map;

public class Common {
    public static Map<String, Object> getPriceInfo(JSONObject routing, JSONObject data) {
        HashMap<String, Object> priceInfo = new HashMap<>();
        priceInfo.put("adultPrice", routing.getDouble("adultPrice"));
        priceInfo.put("adultTax", routing.getDouble("adultTax"));
        priceInfo.put("childPrice", routing.getDouble("childPrice"));
        priceInfo.put("childTax", routing.getDouble("childTax"));
        //data的数据是比较新的
        priceInfo.put("sessionId", data.getString("sessionId"));
        priceInfo.put("pnrCode", data.getString("pnrCode"));
        priceInfo.put("orderNo", data.getString("orderNo"));
        priceInfo.put("routing", data.getJSONObject("routing"));
        return priceInfo;
    }

    /**
     * 加密
     *
     * @param content  需要加密的内容
     * @param password 加密密码
     * @return
     */

    public static String encrypt(String content, String password) throws Exception {
        try {
            byte[] raw = password.getBytes(Charsets.UTF_8);
            if (raw.length != 16) {
                throw new IllegalArgumentException("Invalid key size. " + password + ", 密钥 token 长度不是 16 位");
            }
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, skeySpec, new IvParameterSpec(new byte[16])); // zero IV
            byte[] finalByte = cipher.doFinal(content.getBytes(Charsets.UTF_8));
            return new String(org.apache.commons.codec.binary.Base64.encodeBase64(finalByte));
        } catch (Exception e) {
            throw e;
        }
    }


    /**
     * 加密
     *
     * @param content  需要解密的内容
     * @param password 加密密码
     * @return
     */

    public static String decrypt(String content, String password) throws Exception {
        try {
            byte[] raw = password.getBytes(Charsets.UTF_8);
            if (raw.length != 16) {
                throw new IllegalArgumentException("Invalid key size. " + password + ", 密钥 token 长度不是 16 位");
            }
            SecretKeySpec skeySpec = new SecretKeySpec(raw, "AES");
            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(Cipher.DECRYPT_MODE, skeySpec, new IvParameterSpec(new byte[16]));
            byte[] toDecrypt = org.apache.commons.codec.binary.Base64.decodeBase64(content.getBytes());
            byte[] original = cipher.doFinal(toDecrypt);
            return new String(original, Charsets.UTF_8);
        } catch (IllegalArgumentException e) {
            throw e;
        } catch (Exception e) {
        }
        return null;

    }

}
