package com.kexun.common;
import com.kexun.entity.UserField;
import com.kexun.entity.UserModel;
import com.kexun.service.SysUserService;
import com.kexun.service.UserApprovalService;
import com.kexun.service.UserFieldService;
import com.kexun.service.UserModelService;
import org.springframework.beans.factory.annotation.Autowired;

import javax.annotation.PostConstruct;
import java.util.ArrayList;
import java.util.List;
//准确来说是商户信息
public class User {
    private String user_name;
    private String field_data;
    private String field_state;

    private static UserModelService userModelServices;
    private static UserApprovalService userApprovalServices;
    private static UserFieldService userFieldServices;

    @Autowired
    private UserModelService userModelService;
    @Autowired
    private UserApprovalService userApprovalService;
    @Autowired
    private UserFieldService userFieldService;

    private List<String> model_name=new ArrayList<>();
    private List<String> model_state=new ArrayList<>();

    public String getUser_name() {
        return user_name;
    }

    public List<String> getModel_name() {
        return model_name;
    }

    public String getField_data() {
        return field_data;
    }

    public List<String> getModel_state() {
        return model_state;
    }

    public String getField_state() {
        return field_state;
    }

    public void initUser(String name)
    {
        user_name=name;
        List<UserModel> model_list=userModelServices.findByUserName(user_name);
        if(model_list!=null) {
            for (int i = 0; i < model_list.size(); i++) {
                model_name.add(model_list.get(i).getModelName());
                model_state.add(model_list.get(i).getModelState());
            }
        }
        UserField userField=userFieldServices.findByUserName(user_name);
        if(userField!=null) {
            field_data = userField.getFieldData();
            field_state=userField.getFieldState();
        }
        else
        {
            field_data=null;
            field_state=null;
        }
    }

    @PostConstruct
    public void init(){
        userModelServices = this.userModelService;
        userApprovalServices=this.userApprovalService;
        userFieldServices=this.userFieldService;

    }
}
