package com.kexun.common.utils;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

@Data
public class PageResult implements Serializable {
    public PageResult() {
    }

    public PageResult(List data, long count) {
        this.code = 0;
        this.msg = "";
        this.data = data;
        this.count = count;
    }

    public static PageResult success(List data, long count) {
        return new PageResult(data, count);
    }

    public static PageResult error(String message) {
        PageResult pageResult = new PageResult();
        pageResult.setMsg(message);
        pageResult.setCode(1);
        return pageResult;
    }

    private int code;
    private String msg;
    private List<Object> data;
    private long count;
}
