package com.kexun.common.xss;

import com.kexun.exception.ApiRRException;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;

/**
 * SQL过滤
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2017-04-01 16:16
 */
@Slf4j
public class SQLFilter {

    /**
     * SQL注入过滤
     *
     * @param str 待验证的字符串
     */
    public String filter(String str) {
        if (StringUtils.isBlank(str)) {
            return null;
        }
        //非法字符
        String[] keywords = {"jndi", "master", "truncate", "insert", "select", "delete", "update", "declare", "alert", "drop"};

        //判断是否包含非法字符
        for (String keyword : keywords) {
            if (str.toLowerCase().contains(keyword)) {
                throw new ApiRRException("检测到非法请求造成严重后果将追究其法律责任");
            }
        }
        return str;
    }
}
