package com.kexun.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.kexun.common.redis.RedisUtil;
import com.kexun.common.utils.MD5Utils;
import com.kexun.common.utils.Result;
import com.kexun.entity.SysRights;
import com.kexun.entity.SysRoleRights;
import com.kexun.entity.SysUser;
import com.kexun.service.SysRightsService;
import com.kexun.service.SysRoleRightsService;
import com.kexun.service.SysUserService;
import com.kexun.service.UserInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;
import java.util.concurrent.TimeUnit;

/*
未改动
 * 目标：
 * 目前：
 */
@RestController
@RequestMapping("admin")
public class LoginController {
    @Autowired
    private SysUserService sysUserService;
    @Autowired
    private RedisUtil redisUtil;

    @PostMapping("login")
    public Result login(@RequestBody String json, HttpServletResponse response) {
        System.out.println(json);
        JSONObject req = JSON.parseObject(json);
        String userName = req.getString("username");
        String password = req.getString("password");
        SysUser sysUser = sysUserService.findByUserName(userName);
        if (sysUser == null) {
            return Result.error("用户名不存在");
        }
       String salt = sysUser.getSalt();
        String pass = MD5Utils.md5slat(password, salt, 2);
        if (!sysUser.getPassword().equals(pass)) {
            return Result.error("用户名或密码错误");
        }
        String userId = sysUser.getUserId();
        String token = UUID.randomUUID().toString();
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("token", token);
        jsonObject.put("nickName", sysUser.getShowName());
        redisUtil.setEx(token, userId, 30, TimeUnit.DAYS);
        response.addCookie(new Cookie("ht_token", token));
        return Result.success("登录成功", jsonObject);
    }

    @Autowired
    private SysRoleRightsService sysRoleRightsService;
    @Autowired
    private SysRightsService sysRightsService;

    @Autowired
    private UserInfoService userInfoService;

    @GetMapping("userInfo")
    public Result userInfo(SysUser sysUser) {
        String showName = sysUser.getShowName();
        String userName=sysUser.getUserName();
        JSONObject resJson = new JSONObject();
        resJson.put("nickName", showName);
        resJson.put("userName",userName);
        Long roleId = sysUser.getRoleId();
        List<SysRoleRights> sysRoleRights = sysRoleRightsService.list(new QueryWrapper<SysRoleRights>().eq("role_id", roleId).orderByAsc("right_id"));
        ArrayList<SysRights> sysRights = new ArrayList<>();
        for (SysRoleRights sysRoleRight : sysRoleRights) {
            SysRights rights = sysRightsService.getById(sysRoleRight.getRightId());
            sysRights.add(rights);
        }
        JSONArray rights = new JSONArray();
        for (SysRights sysRight1 : sysRights) {
            if (sysRight1.getParentId() == 0) {
                JSONObject right = new JSONObject();
                right.put("path", sysRight1.getRightUrl());
                right.put("name", sysRight1.getRightName());
                right.put("component", sysRight1.getComponent());
                JSONObject meta = new JSONObject();
                meta.put("keepAlive", true);
                meta.put("show", sysRight1.getIsShow());
                meta.put("icon",sysRight1.getRightIcon());
                right.put("meta", meta);
                JSONArray children = new JSONArray();
                for (SysRights sysRight2 : sysRights) {
                    if (sysRight2.getParentId() == sysRight1.getId()) {
                        JSONObject right2 = new JSONObject();
                        right2.put("path", sysRight2.getRightUrl());
                        right2.put("name", sysRight2.getRightName());
                        right2.put("component", sysRight2.getComponent());
                        JSONObject meta2 = new JSONObject();
                        meta2.put("keepAlive", true);
                        meta2.put("show", sysRight2.getIsShow());
                        meta2.put("icon",sysRight2.getRightIcon());
                        right2.put("meta", meta2);
                        children.add(right2);
                    }
                }
                right.put("children", children);
                rights.add(right);
            }

        }
        resJson.put("rights", rights);

        return Result.success("ok", resJson);
    }





}
