package com.kexun.controller;

//import ch.qos.logback.core.rolling.helper.FileStoreUtil;
//import ch.qos.logback.core.util.FileUtil;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.kexun.common.utils.Result;
import com.kexun.entity.CreditApproval;
import com.kexun.entity.CreditUpload;
import com.kexun.entity.FilterResult;
import com.kexun.entity.ParseAuto;
import com.kexun.service.CreditApprovalService;
import com.kexun.service.CreditUploadService;
import com.kexun.service.FilterResultService;
import com.kexun.service.ParseAutoService;
import lombok.extern.java.Log;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/*
新添加
 * 目标：实现解析相关操作接口
 * 目前：只有简单的罗列解析结果，前端待添加相应的操作，并实现接口
 */

@RestController
@RequestMapping("/admin/parse")
@Log
public class ParseController {

    @Autowired
    private FilterResultService parseResultService;
    @Autowired
    private CreditUploadService creditUploadService;
    @Autowired
    private CreditApprovalService creditApprovalService;
    @Autowired
    private ParseAutoService parseAutoService;

    //报告名
    @GetMapping("list")
    public Result list(String reportName) {
        QueryWrapper<FilterResult> w = new QueryWrapper<>();
        if (!StringUtils.isEmpty(reportName)) {
            w.like("report_name", reportName);
        }

        List<FilterResult> list = parseResultService.list(w);
        return Result.success("ok", list);
    }

    //自动解析状态
    @GetMapping("autoList")
    public Result autoList(String reportName) {
        QueryWrapper<ParseAuto> w = new QueryWrapper<>();
        if (!StringUtils.isEmpty(reportName)) {
            w.like("report_name", reportName);
        }

        List<ParseAuto> list = parseAutoService.list(w);
        return Result.success("ok", list);
    }

    //征信报告上传罗列
    @GetMapping("creditReportList")
    public Result CreditReportList(String fileName) {
        QueryWrapper<CreditUpload> w = new QueryWrapper<>();
        if (!StringUtils.isEmpty(fileName)) {
            w.like("file_name", fileName);
        }

        List<CreditUpload> list = creditUploadService.list(w);
        return Result.success("ok", list);
    }


    //征信报告征信结果上传罗列
    @GetMapping("creditApprovalList")
    public Result creditApprovalList(String creditName) {
        QueryWrapper<CreditApproval> w = new QueryWrapper<>();
        if (!StringUtils.isEmpty(creditName)) {
            w.like("credit_name", creditName);
        }

        List<CreditApproval> list = creditApprovalService.list(w);
        return Result.success("ok", list);
    }
    //上传文件相关信息入库
    @PostMapping("creditReportAdd")
    @Transactional
    public Result add(@RequestBody JSONObject param) {
        String fileName = param.getString("name");
        CreditUpload creditUpload = new CreditUpload();
        creditUpload.setFileName(fileName);

        creditUploadService.save(creditUpload);

        return Result.success();
    }

}
