package com.kexun.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.kexun.common.utils.Result;
import com.kexun.entity.ParseAuto;
import com.kexun.service.ParseAutoService;
import lombok.extern.java.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.springframework.beans.factory.annotation.Configurable;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.stereotype.Component;
import org.springframework.scheduling.annotation.Scheduled;

/**
 * @Author shixiaorong
 * @Date 2022/9/20 15:47
 */
/*
 * 目标：实现全字段自动解析
 * 目前：已实现，并计划添加调用python解析脚本的接口
 * 应该是自动解析的自动解析，用户上传的再由前端发请求，调用相应接口，实现解析、过滤、逻辑判断
 */

@RestController
@RequestMapping("/admin/python")
@Log
@Component
@Configurable
@EnableScheduling

public class TimingPlan {

    @Autowired
    private ParseAutoService parseAutoService;

    String statu = "";


    @PostMapping("parseAuto")
    public Result auto(@RequestBody String json)throws IOException{
        JSONObject req = JSON.parseObject(json);
        String status = req.getString("remark");
        statu = status;
        ParseAuto parseAuto = new ParseAuto();

        Calendar calendar = Calendar.getInstance();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String startTime = formatter.format(calendar.getTime());

        String autoStatus = "";
        if (statu.equals("do")) {
            autoStatus = "已启动";
            parseAuto.setParseAutoStatus(autoStatus);
            parseAuto.setStartedTime(startTime);
            parseAutoService.save(parseAuto);
        }
        else{
            autoStatus = "已暂停";
            parseAuto.setParseAutoStatus(autoStatus);
            parseAuto.setStartedTime(startTime);
            parseAutoService.save(parseAuto);
        }

        return Result.success();

    }
    //自动解析函数
    @Scheduled(cron = " 0/10 * * * * ? ")
    public void doTimingPlan() throws IOException {
        if(statu.equals("do")){
            File file = new File("D:\\jin_rong\\todo\\execed_xml");
            File[] files = file.listFiles();
            for (File file1 : files){
/*
            System.out.println(file1.getName());
*/
//            if(file1.getName().charAt(file1.getName().length() - 1) != '*'){
//
//            }
                String[] args = new String[] { "D:\\data\\pythonProject\\venv\\Scripts\\python.exe", "D:/data/nk/lab/szx/read_pdf_plt/parseCreditXmlAuto.py", file1.getName()};
                Process proc;
                try {
                    proc = Runtime.getRuntime().exec(args);
//                BufferedReader in = new BufferedReader(new InputStreamReader( proc.getInputStream() ));
//                String actionStr = null;
//                while ((actionStr = in.readLine()) != null)
//                    System.out.println(actionStr);
//                in.close();
                    proc.waitFor();
                } catch (InterruptedException e){
                    e.printStackTrace();
                }
            }
        }
        else
//            statu = "pause";
            System.out.println("parse pause");
    }

    @PostMapping("doParse")
    public Result doParse(@RequestBody String json) throws IOException {
        JSONObject req = JSON.parseObject(json);
        String filename = new String();
        filename = req.getString("fileName");
        System.out.println(filename);
/*
        System.out.println(file1.getName());
*/
//            if(file1.getName().charAt(file1.getName().length() - 1) != '*'){
//
//            }
        String[] args = new String[] { "D:\\data\\pythonProject\\venv\\Scripts\\python.exe", "D:/data/nk/lab/szx/read_pdf_plt/parseCreditXmlModel.py", filename};
        Process proc;
        try {
            proc = Runtime.getRuntime().exec(args);
            System.out.println(proc);
                BufferedReader in = new BufferedReader(new InputStreamReader( proc.getInputStream() ));
                String actionStr = null;
                while ((actionStr = in.readLine()) != null)
                    System.out.println(actionStr);
                in.close();
            proc.waitFor();
        } catch (InterruptedException e){
            e.printStackTrace();
        }
        return Result.success();

    }

}
