package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;

/**
 * @TableName customized_model
 */
@TableName(value = "customized_model")
@Data
public class CustomizedModel implements Serializable {
    /**
     * 模型名
     */
    @TableField(value = "model_name")
    private String modelName;
    /**
     * 类别名
     */
    @TableField(value = "field_class")
    private String fieldClass;

    /**
     * 所选字段列表
     */
    @TableId(value = "id_list")
    private String idList;

    /**
     * 插入数据者
     */
    @TableField(value = "created_by")
    private String createdBy;

    /**
     * 读数据者
     */
    @TableField(value = "read_by")
    private String readBy;

    /**
     * 更新数据者
     */
    @TableField(value = "updated_by")
    private String updatedBy;

    /**
     * 删除数据者
     */
    @TableField(value = "deleted_by")
    private String deletedBy;

    /**
     * 备注
     */
    @TableField(value = "model_remark")
    private String modelRemark;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}