package com.kexun.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @TableName field_table
 */
@TableName(value = "field_table")
@Data
public class FieldTable implements Serializable {
    /**
     * 类别名
     */
    @TableField(value = "field_class")
    private String fieldClass;

    /**
     * 属性名
     */
    @TableId(value = "field_name")
    private String fieldName;

    /**
     * 插入数据者
     */
    @TableField(value = "created_by")
    private String createdBy;

    /**
     * 读数据者
     */
    @TableField(value = "read_by")
    private String readBy;

    /**
     * 更新数据者
     */
    @TableField(value = "updated_by")
    private String updatedBy;

    /**
     * 删除数据者
     */
    @TableField(value = "deleted_by")
    private String deletedBy;

    /**
     * 校验属性值是否合法
     */
    @TableField(value = "extra_data")
    private String extraData;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;
}