package com.kexun.hander;

import com.kexun.exception.ApiRRException;
import com.kexun.common.utils.Result;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestControllerAdvice;

@RestControllerAdvice
public class RRExceptionHandler {
    private Logger logger = LoggerFactory.getLogger(getClass());

    //api异常
    @ResponseBody
    @ExceptionHandler(ApiRRException.class)
    public Result handleApiRRException(ApiRRException e) {
        return new Result(e.getErrno(), e.getErrmsg());
    }

    @ResponseBody
    @ExceptionHandler(Exception.class)
    public Result handleApiRRException(Exception e) {
        e.printStackTrace();
        return new Result(500, "系统服务异常");
    }
}
