package com.kexun.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.entity.CooperatorField;
import com.kexun.entity.CooperatorInfo;
import com.kexun.entity.CooperatorProduct;
import com.kexun.entity.UserField;
import com.kexun.mapper.CooperatorMapper;
import com.kexun.service.CooperatorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 *
 */
@Service
public class CooperatorServiceImpl extends ServiceImpl<CooperatorMapper, CooperatorInfo>
    implements CooperatorService {
    @Override
    public CooperatorInfo findByCooperatorNum(String partnerName) {
        QueryWrapper wrapper=new QueryWrapper();
        wrapper.eq("cooperator_name",partnerName);
        return getOne(wrapper);
    }

    @Resource
    CooperatorMapper cooperatorMapper;

    @Override
    public List<CooperatorField> findCooperatorFieldByNum(String cooperatorNum) {
//        System.out.println("aaa");
        List<CooperatorField> l = cooperatorMapper.Query(cooperatorNum);
        return l;
    }

    @Override
    public List<CooperatorProduct> findCooperatorProductByNum(String cooperatorNum) {
//        System.out.println("aaa");
        List<CooperatorProduct> l = cooperatorMapper.QueryProduct(cooperatorNum);
        return l;
    }

    @Override
    public CooperatorInfo findByID(long id) {
        QueryWrapper<CooperatorInfo> wrapper=new QueryWrapper<CooperatorInfo>().eq("id",id);
        return getOne(wrapper);
    }

}




