package com.kexun.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.entity.UserModel;
import com.kexun.mapper.UserModelMapper;
import com.kexun.service.UserModelService;
import org.springframework.stereotype.Service;

import java.util.List;
@Service
public class UserModelServiceImpl extends ServiceImpl<UserModelMapper,UserModel>
    implements UserModelService
{

    @Override
    public List<UserModel> findByUserName(String user_name) {

        QueryWrapper<UserModel> wrapper=new QueryWrapper<UserModel>().eq("user_name",user_name);
        List<UserModel> model_list=list(wrapper);
        return model_list;
    }

    @Override

    public UserModel findByModelName(String model_name)
    {
        QueryWrapper<UserModel> wrapper=new QueryWrapper<UserModel>().eq("model_name",model_name);

        return getOne(wrapper);

    }
    @Override

    public UserModel findByUserAndModel(String user_name,String model_name)
    {
        QueryWrapper<UserModel> wrapper=new QueryWrapper<UserModel>().eq("user_name",user_name);
        wrapper.eq("model_name",model_name);
        return getOne(wrapper);

    }

    @Override
    public UserModel findByID(long id) {
        QueryWrapper<UserModel> wrapper=new QueryWrapper<UserModel>().eq("id",id);
        return getOne(wrapper);
    }

    @Override
    public void removeModelByID(long id) {
        QueryWrapper<UserModel> wrapper=new QueryWrapper<UserModel>().eq("id",id);
        remove(wrapper);
    }


}
